package mil.navy.spawar.ssclant.ntcssoa.workflow;

import java.io.IOException;
import java.io.Reader;
import java.util.List;
import java.util.Map;

import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import mil.navy.spawar.ssclant.ntcssoa.task.local.LocalTaskClientConnector;
import mil.navy.spawar.ssclant.ntcssoa.task.local.LocalTaskClientHandler;

import org.drools.SystemEventListenerFactory;
import org.jboss.soa.esb.client.ServiceInvoker;
import org.jboss.soa.esb.couriers.FaultMessageException;
import org.jboss.soa.esb.listeners.message.MessageDeliverException;
import org.jboss.soa.esb.message.Message;
import org.jboss.soa.esb.services.registry.RegistryException;
import org.jbpm.task.AccessType;
import org.jbpm.task.AllowedToDelegate;
import org.jbpm.task.Attachment;
import org.jbpm.task.BooleanExpression;
import org.jbpm.task.Comment;
import org.jbpm.task.Deadline;
import org.jbpm.task.Deadlines;
import org.jbpm.task.Delegation;
import org.jbpm.task.Escalation;
import org.jbpm.task.Group;
import org.jbpm.task.I18NText;
import org.jbpm.task.Notification;
import org.jbpm.task.OrganizationalEntity;
import org.jbpm.task.PeopleAssignments;
import org.jbpm.task.Reassignment;
import org.jbpm.task.Status;
import org.jbpm.task.Task;
import org.jbpm.task.TaskData;
import org.jbpm.task.User;
import org.jbpm.task.query.TaskSummary;
import org.jbpm.task.service.TaskClient;
import org.jbpm.task.service.TaskService;
import org.jbpm.task.service.TaskServiceSession;
import org.jbpm.task.service.mina.MinaTaskClientConnector;
import org.jbpm.task.service.mina.MinaTaskClientHandler;
import org.jbpm.task.service.mina.MinaTaskServer;
import org.mvel2.MVEL;
import org.mvel2.ParserContext;
import org.mvel2.compiler.ExpressionCompiler;

public class MinaServerManager {
	private static final String address = "127.0.0.1";
	private static final int port = 9123;
	private static Thread minaThread = null;
	private static MinaTaskServer server = null;
	private static boolean started = false;
	
	@SuppressWarnings("unchecked")
	private static Object eval(Reader reader, Map vars) {
        try {
            return eval( readerToString( reader ), vars );
        } catch ( IOException e ) {
            throw new RuntimeException( "Exception Thrown", e );
        }
    }
    
    private static String readerToString(Reader reader) throws IOException {
        int charValue = 0;
        StringBuffer sb = new StringBuffer( 1024 );
        while ( (charValue = reader.read()) != -1 ) {
            //result = result + (char) charValue;
            sb.append( (char) charValue );
        }
        return sb.toString();
    }
    
    @SuppressWarnings({ "deprecation", "unchecked" })
	private static Object eval(String str, Map vars) {
        ExpressionCompiler compiler = new ExpressionCompiler( str.trim() );

        ParserContext context = new ParserContext();
        context.addPackageImport( "org.jbpm.task" );
        context.addPackageImport( "java.util" );
        
        context.addImport( "AccessType", AccessType.class );
        context.addImport( "AllowedToDelegate", AllowedToDelegate.class );
        context.addImport( "Attachment", Attachment.class );
        context.addImport( "BooleanExpression", BooleanExpression.class );
        context.addImport( "Comment", Comment.class );
        context.addImport( "Deadline", Deadline.class );
        context.addImport( "Deadlines", Deadlines.class );
        context.addImport( "Delegation", Delegation.class );
        context.addImport( "Escalation", Escalation.class );
        context.addImport( "Group", Group.class );
        context.addImport( "I18NText", I18NText.class );
        context.addImport( "Notification", Notification.class );
        context.addImport( "OrganizationalEntity", OrganizationalEntity.class );
        context.addImport( "PeopleAssignments", PeopleAssignments.class );
        context.addImport( "Reassignment", Reassignment.class );
        context.addImport( "Status", Status.class );
        context.addImport( "Task", Task.class );
        context.addImport( "TaskData", TaskData.class );
        context.addImport( "TaskSummary", TaskSummary.class );
        context.addImport( "User", User.class );

        return MVEL.executeExpression( compiler.compile( context ), vars );
    }
    private synchronized static void initializeIdentities(TaskServiceSession taskSession)
    {
    	if(taskSession != null)
    	{
    		System.out.println("Getting Task Service Identities");
	    	Message message = org.jboss.soa.esb.message.format.MessageFactory.getInstance().getMessage();
	    	Message response = null;
	    	ServiceInvoker invoker = null;
	    	try {
				invoker = new ServiceInvoker("ActionServices", "IdentityActionService");
				response = invoker.deliverSync(message, 60000);
			} catch (MessageDeliverException e) {
				// TODO Auto-generated catch block
				e.printStackTrace(System.out);
			} catch (FaultMessageException e) {
				// TODO Auto-generated catch block
				e.printStackTrace(System.out);
			} catch (RegistryException e) {
				// TODO Auto-generated catch block
				e.printStackTrace(System.out);
			}
			
			if(response != null && response.getBody() != null)
			{
				Object usersObj =response.getBody().get("users");
				Object groupsObj = response.getBody().get("groups");
				if(usersObj != null && usersObj instanceof List<?>)
				{
					//TODO: Find out how to load users from the database
					try
					{
						System.out.println("Loading Task Service Users");
						for(String user : (List<String>)usersObj)
						{
							taskSession.addUser( new User(user) );
							System.out.println("Loaded User "+user);
						}
						System.out.println("Loaded Task Service Users");
					}
					catch(Exception e)
					{}
				}
				if(groupsObj != null && groupsObj instanceof List<?>)
				{
					//TODO: Find out how to load group from the database
					try
					{
						System.out.println("Loading Task Service Groups");
						for(String group : (List<String>)groupsObj)
						{
							taskSession.addGroup( new Group(group) );
							System.out.println("Loaded Group "+group);
						}
						System.out.println("Loaded Task Service Groups");
					}
					catch(Exception e)
					{}
				}
			}
			System.out.println("Task Service Identities Loaded");
    	}
    	else
    	{
    		System.out.println("Task Service Identities not loaded because TaskServiceSession is null");
    	}
    }
    private static TaskClient createClient()
    {
    	 TaskClient client = new TaskClient(new MinaTaskClientConnector(
					"org.drools.process.workitem.wsht.WSHumanTaskHandler",
					new MinaTaskClientHandler(SystemEventListenerFactory.getSystemEventListener())));
    	 
		boolean connected = client.connect(address, port);
		if (!connected) {
			client = null;
		}
		
		return client;
    }
	
	private synchronized static void start()
	{
		
		if(!started && (createClient() == null))
		{
			System.out.println("Creating TaskService");
			
	        //EntityManagerFactory emfTask = Persistence.createEntityManagerFactory("");
	        
			EntityManagerFactory emfTask = Persistence.createEntityManagerFactory("org.jbpm.task.ntcssoa");
	        TaskService taskService = new TaskService(emfTask, SystemEventListenerFactory.getSystemEventListener());
	        
	        TaskServiceSession taskSession = taskService.createSession();
	        System.out.println("Establishing users and groups");
	        // Add users
	        initializeIdentities(taskSession);
	        // start server
	        System.out.println("Creating Mina server");
	        server = new MinaTaskServer(taskService);
	        minaThread = new Thread(server);
	        System.out.println("Starting Mina server");
	        minaThread.setDaemon(true);
	        minaThread.start();
	        taskSession.dispose();
	        int retries = 0;
	        while((createClient() == null) && retries < 10)
	        {
	        	try {
	        		System.out.println("sleeping for 6 secs");
					Thread.currentThread();
					Thread.sleep(6000);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					System.out.println("Error occurred while sleeping");
					e.printStackTrace(System.out);
					break;
				}
	        }
	        
	        started =  (createClient() != null);
	        System.out.println("Mina server is "+(started ? "started" : "not started"));
		}
		else
		{
			started = true;
		}
	}
	public synchronized static void stop()
	{
		if(server != null)
		{
			if(server.isRunning())
			{
				server.stop();
			}
			server = null;
		}
		if(minaThread != null)
		{
			if(minaThread.isAlive())
			{
				minaThread.stop();
			}
			minaThread = null;
		}
	}
	public static TaskClient connect()
	{
		TaskClient client = null;
		// If the MINA Server isn't started, then start it.
		if(!started)
		{
			start();
		}
		// Verify that the MINA server started before creating the client
		if(started)
		{
			 client = createClient();
		}

		return client;
	}
	/*public static TaskClient connect()
	{
		TaskClient client = new TaskClient(new LocalTaskClientConnector("org.drools.process.workitem.wsht.WSHumanTaskHandler",
									new LocalTaskClientHandler(SystemEventListenerFactory.getSystemEventListener())));
			
		boolean connected = client.connect();
		if (!connected) {
			client = null;
		}
		return client;
	}*/
	public static void disconnect(TaskClient client)
	{
		if (client != null) {
			try {
				client.disconnect();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
}
